package SGP_Backend.SGP_Backend.model;

public class Usuario {
    private Long id;
    private String nome;
    private TipoUsuario tipo;
    private String email;
    private String senha;

    public Long getId() {
        return id;
    }

    public String getNome() {
        return nome;
    }

    public TipoUsuario getTipo() {
        return tipo;
    }

    public String getEmail() {
        return email;
    }

    public String getSenha() {
        return senha;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public void setNome(String nome) {
        this.nome = nome;
    }

    public void setTipo(TipoUsuario tipo) {
        this.tipo = tipo;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public void setSenha(String senha) {
        this.senha = senha;
    }

    public Usuario(Long id, String nome, TipoUsuario tipo, String email, String senha) {
        this.id = id;
        this.nome = nome;
        this.tipo = tipo;
        this.email = email;
        this.senha = senha;
    }

    public void validarUsuario() {
        if (this.nome == null || this.nome.isEmpty()) {
            throw new IllegalArgumentException("Nome do usuário não pode ser vazio");
        }
         if (!tipo.matches("Admin|User|Guest|Moderator")) {
            throw new IllegalArgumentException("Tipo de usuário inválido");
        }
         if (this.email == null || this.email.isEmpty()) {
            throw new IllegalArgumentException("Email do usuário não pode ser vazio");
         }
}
}
